Program TVSO;

 Uses
   Dos, Objects, Drivers, Views, Menus, Dialogs, App;
 const
   {These constants identify the menu item that is selected.}
   cmNew	    = 100;
   cmOpen	    = 101;
   cmSave	    = 102;
   cmSaveas	    = 103;

   cmView           = 104;
   cmPrint	    = 105;
   cmSetup	    = 106;

   cmHelp	    = 107;
   cmAbout	    = 108;

 type
   TSchTypeData = record
      SchType:Word;
     End;
   PDirectoryWindow = ^TDirectoryWindow;
   TDirectoryWindow = object(TWindow)
   { This is the directory window, derived from the
     TWindow object. }
   end; { TDirectoryWindow }

   TSO = object(TApplication)
     SchTypeData : TSchTypeData;     
{    SchWindow : TSchWindow;
     PSchWindow : ^TSchWindow;
}    CKNAME,DLNAME,WKNAME:String;
     TDirectoryWindow : PDirectoryWindow;
     {Methods}
     constructor Init;
     procedure HandleEvent(var Event: TEvent); virtual;
     procedure InitMenuBar; virtual;
     procedure InitStatusLine; virtual;
     Procedure NewDialog;
     Procedure ScheduleWindow;
     Procedure SaveDialog;
   end; { TSO }
     PDirList = ^TDirList;
     TDirList = object(TListViewer)
     Constructor Init;
     function GetText ( Item : Integer; MaxLen : Integer) : String; virtual;
     procedure ReadDirectory  ( StartingEntry : Integer;
                              Path : String;
                              SubLevel : Integer ); virtual;
   

    function GetPalette: PPalette; virtual;
  end;
    PDirectoryEntry = ^TDirectoryEntry;
  TDirectoryEntry= object( TObject )
    Level   : Byte;
    FileNumber : Integer;
    Selected : Boolean;
    DirInfo : SearchRec;
    constructor Init( NewLevel:Byte; NewFileNumber : Integer;
                      NewDirInfo : SearchRec );
  end; { TDirectoryEntry }

 Var
   SO:TSO;
   ListObject : PDirList;
   DirectoryCollection : PCollection;

 function TDirList.GetText
  ( Item : Integer; MaxLen : Integer) : String;
{ Purpose:
  The TListViewer calls this routine to get a line of text to display
  in the directory list box.  The format of the output string is
  a prefix character, indicating if the file has been selected or
  not selected, followed by the optional outline numbering [not yet
  implemented in TVSHELL6], followed by the file or directory name.
}

var
  TempEntry : PDirectoryEntry;
  Prefix : Char;

begin
  { Item ranges from 0 to DirecoryCollecion^.Count - 1 }
  if  Item < DirectoryCollection^.Count  then
  begin
    TempEntry := DirectoryCollection^.At(Item);
    if  TempEntry^.Selected  then
      Prefix := '>'
    else
      Prefix := ' ';
    GetText := Prefix + TempEntry^.DirInfo.Name;
  end
  else
    GetText := '';

end; { TDirList.GetText }

function LowerCase (S : String ) : String;

var
  I : Integer;

begin

  for I := 1 to length(s)  do
    if ((S[I]>='A') and (S[I]<='Z'))  then
      S[I] :=  Chr( Ord( S[I] ) + 32 );
  LowerCase := S;

end; { LowerCase }

procedure TDirList.ReadDirectory
  ( StartingEntry : Integer;
    Path : String;
    SubLevel : Integer );

{ Purpose:
  Reads the directory contents specified by CurrentPath and inserts
  the list into the directory list beginning at 'StartingEntry'.

  Returns:
  The address in the list where it began storing the current directory
}

var
  DirEntry : SearchRec;  { Holds the contents of a directory entry
                           consisting of filename, size, etc }
  FileCount : Integer;

begin

  FindFirst( Path + '*.*', AnyFile, DirEntry );
  FileCount := 0;
  while  DosError = 0  do
  begin
    if  DirEntry.Name[1] <> '.'  then
      {Add all names other than those beginning with '.'.  This
       eliminates our displaying the '.' and '..' names used by DOS}
    begin
      if  (DirEntry.Attr AND Directory) <> Directory  then
        DirEntry.Name := LowerCase (DirEntry.Name);
        {We convert file names to lowercase and leave directory names
         in upper case for ease of reading the directory listing}
      FileCount := FileCount + 1;
      DirectoryCollection^.Insert(New(PDirectoryEntry,
                Init( SubLevel, FileCount, DirEntry )));
    end; { begin }
    FindNext( DirEntry );
  end; { begin }

  { Update the List box viewer to indicate how many directory entries
    we currently have in our collection.  This tells the scroll bar
    and scrolling code how far down its okay to scroll. }
  ListObject^.SetRange(DirectoryCollection^.Count);

end; {ReadDirectory}

{constructor TDirectoryWindow.Init( Bounds: TRect; WinTitle : String; WindowNo : Integer );

var
  BarBounds : TRect;
  ListScroller : PScrollBar;

begin
  
  TWindow.Init ( Bounds, WinTitle, WindowNo );
  Flags := byte ( not (wfMove or wfGrow or wfClose or wfZoom) );

  GetExtent( Bounds );

  
  Bounds.Grow (-2, -1);

  BarBounds := Bounds;

  BarBounds.B.X := BarBounds.B.X + 1;
  BarBounds.A.X := Bounds.B.X;
  ListScroller := New (PScrollBar, Init(BarBounds));
  ListObject :=
     New(PDirList, Init(Bounds, 1,
         NIL,
         ListScroller ));
  ListObject^.SetRange(100);
  Insert(ListScroller);
  Insert(ListObject);
  DirectoryCollection := New(PCollection, Init(100,50));
  ListObject^.ReadDirectory (1, '\', 1);

end; 
}
 procedure TSO.InitMenuBar;
 {Purpose:
 Defines the pulldown menus used in TVShell.}

 var
   Bounds: TRect;

 begin

  TSO.GetExtent(Bounds);
  Bounds.B.Y := Bounds.A.Y + 1;
  MenuBar := New(PMenuBar, Init(Bounds, NewMenu(
    NewSubMenu('~F~ile', hcNoContext, NewMenu(
      NewItem('~N~ew', '', 0, cmNew,
	       hcNoContext,
      NewItem('~O~pen', 'Alt-O', kbAltO, cmOpen,
	       hcNoContext,
      NewItem('~S~ave', 'Alt-S', kbAltS, cmSave,
	       hcNoContext,
      NewItem('~S~ave as...','', 0, cmSaveas,
	       hcNoContext,
      NewItem('E~x~it', 'Alt-X', kbAltX, cmQuit,
	       hcNoContext,
      nil)))))),
    NewSubMenu('~O~ptions', hcNoContext, NewMenu(
      NewItem('~V~iew schedule', 'Alt-V', kbAltV, cmView, hcNoContext,
      NewItem('~P~rint', 'F3', kbF3, cmPrint, hcNoContext,
      NewItem('~S~etup', '', 0, cmSetup, hcNoContext,
      nil)))),
    NewSubMenu ('~H~elp', hcNoContext, NewMenu(
      NewItem('~H~elp index', 'F1', kbF1,
	       cmHelp, hcNocontext,
      NewItem('~A~bout', '', 0, cmAbout,
	       hcNoContext,
      nil))),
    nil)))
  )));

end; { TSO.InitMenuBar }

procedure TSO.InitStatusLine;
{ Purpose:
  Defines the Status Line shown on the bottom line
  of the screen within TVShell.
}
var
  Bounds: TRect;

begin

  GetExtent(Bounds);
  Bounds.A.Y := Bounds.B.Y - 1;
  StatusLine := New(PStatusLine, Init(Bounds,
    NewStatusDef(0, $FFFF,
      NewStatusKey('', kbF10, cmMenu,
      NewStatusKey('~Alt-X~ Exit', kbAltX, cmQuit,
      NewStatusKey('~F2~ View', kbAltV, cmView,
      NewStatusKey('~F3~ Print', kbAltP, cmPrint,
      nil)))),
    nil)
  ));

end; { TShell.InitStatusLine }

{-------------------------------------------------------------}

procedure TSO.NewDialog;

{ Purpose:
  Implements the new dialog for the SO program.
}

var
  Dialog : PDialog;
  Bounds : TRect;
  Control : Word;
  SchType : PView;

begin

  { Define the location and size of the dialog box for Copy }
  Bounds.Assign ( 15, 5, 59, 18 );
  Dialog := New (PDialog, Init( Bounds, 'Start New Schedule' ));

  { Set up the contents of the Set up dialog }
  with  Dialog^  do
  begin

    { Create the Okay and Cancel buttons }
    Bounds.Assign (7, 10, 18, 12 );
    Insert( New( PButton,
             Init( Bounds, '~C~reate', cmOk, bfDefault )));
    Bounds.Assign ( 24, 10, 35, 12 );
    Insert( New( PButton,
             Init( Bounds, '~C~ancel', cmCancel, bfNormal )));

    Bounds.Assign(3, 2, 41, 5);
    SchType := New (PRadioButtons, Init (Bounds,
           NewSItem('~C~hecklist',
           NewSItem('~D~aily Schedule',
           NewSItem('~W~eekly Schedule',
           nil)))
           ));
    Insert(SchType);

  end; { with }

  SchType^.Select; { Move initial default focus to this group }

  Dialog^.SetData( SchTypeData );

  Control := DeskTop^.ExecView (Dialog);
  Dispose (Dialog, Done);
  if  Control <> cmCancel  then

    Dialog^.GetData( SchTypeData );
end; { TShell.SetUpDialog }

procedure TSO.SaveDialog;

{ Purpose:
  Implements the new dialog for the SO program.
}

var
  Dialog : PDialog;
  Bounds,SBounds : TRect;
  Control : Word;
  SchType : PView;

begin

  { Define the location and size of the dialog box for Copy }
 { Bounds.Assign ( 15, 5, 59, 18 );
  Dialog := New (PDialog, Init( Bounds, 'Save Schedule' ));}

  { Set up the contents of the Set up dialog }
  with  Dialog^  do
  begin

    { Create the Okay and Cancel buttons }
    {Bounds.Assign (7, 10, 18, 12 );
    Insert( New( PButton,
             Init( Bounds, '~S~ave', cmOk, bfDefault )));
    Bounds.Assign ( 24, 10, 35, 12 );
    Insert( New( PButton,
             Init( Bounds, '~C~ancel', cmCancel, bfNormal )));
    GetExtent(SBounds);
    Bounds.B.Y:=SBounds.B.Y - 4;
    Init(SBounds,'Save Schedule',1);
    SaveDialog := PSaveDialog(Resource.Get('About'));
    }
  end; { with }

  SchType^.Select; { Move initial default focus to this group }

  Dialog^.SetData( SchTypeData );

  Control := DeskTop^.ExecView (Dialog);
  Dispose (Dialog, Done);
  if  Control <> cmCancel  then

    Dialog^.GetData( SchTypeData );
end; { TShell.SetUpDialog }

Procedure TSO.ScheduleWindow;

 Var
   Bounds:TRect;

 Begin

 
  
  
  Case SchTypeData.SchType Of
   0:Begin
        
        GetExtent( Bounds );
        Bounds.B.Y := Bounds.B.Y - 2;  { Leave space for the
				   status line. }
        SchWindow := New( PSchWindow,
                    Init(Bounds, CKNAME ,0));
        DeskTop^.Insert(SchWindow);
     End;
   1:Begin
        GetExtent( Bounds );
        Bounds.B.Y := Bounds.B.Y - 2;  { Leave space for the
				   status line. }
        SchWindow := New( PSchWindow,
                    Init(Bounds, DLNAME ,0));
        DeskTop^.Insert(SchWindow);
     End;
   2:Begin
        GetExtent( Bounds );
        Bounds.B.Y := Bounds.B.Y - 2;  { Leave space for the
				   status line. }
        SchWindow := New( PSchWindow,
                    Init(Bounds, WKNAME ,0));
        DeskTop^.Insert(SchWindow);
     End;

  End;
 End;

Procedure TSO.HandleEvent(var Event: TEvent);

Begin  

  CKNAME:='NONAME.CKS';
  DLNAME:='NONAME.DLS';
  WKNAME:='NONAME.WKS';
  TApplication.HandleEvent(Event);
  if (Event.What and evCommand)<>0 then
  begin
    case Event.Command of
      cmNew : Begin NewDialog; ScheduleWindow; End; 
      cmSave: SaveDialog;
    else
      Exit;
    end;
    ClearEvent(Event);
  end;

end; { TShell.HandleEvent }


Begin
 RegisterType(SaveDialog);
 Resource.Init(New(PBufStream, Init('
 SO.Init;
 SO.Run;
 SO.Done;
End.